Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 86740)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 86742)
@@ -411,7 +411,8 @@
     m_pInvisibleRootNode = new UIChooserNodeGroup(0 /* parent */,
                                                   0 /* position */,
-                                                  true /* opened */,
+                                                  QUuid() /* id */,
                                                   QString() /* name */,
-                                                  UIChooserNodeGroupType_Local);
+                                                  UIChooserNodeGroupType_Local,
+                                                  true /* opened */);
     if (invisibleRoot())
     {
@@ -1078,9 +1079,10 @@
                                                           UIChooserNodeDataPrefixType_Provider,
                                                           strProviderShortName),
+                                   uProviderId,
+                                   strProviderShortName,
+                                   UIChooserNodeGroupType_Provider,
                                    shouldGroupNodeBeOpened(invisibleRoot(),
                                                            UIChooserNodeDataPrefixType_Provider,
-                                                           strProviderShortName),
-                                   strProviderShortName,
-                                   UIChooserNodeGroupType_Provider);
+                                                           strProviderShortName));
         pProviderNode->setProperty("id", uProviderId);
 
@@ -1108,9 +1110,10 @@
                                                               UIChooserNodeDataPrefixType_Profile,
                                                               strProfileName),
+                                       QUuid() /* id */,
+                                       strProfileName,
+                                       UIChooserNodeGroupType_Profile,
                                        shouldGroupNodeBeOpened(pProviderNode,
                                                                UIChooserNodeDataPrefixType_Profile,
-                                                               strProfileName),
-                                       strProfileName,
-                                       UIChooserNodeGroupType_Profile);
+                                                               strProfileName));
 
             /* Add fake cloud VM item: */
@@ -1250,9 +1253,10 @@
                                                       UIChooserNodeDataPrefixType_Local,
                                                       strSecondSubName),
+                               QUuid() /* id */,
+                               strSecondSubName,
+                               UIChooserNodeGroupType_Local,
                                fAllGroupsOpened || shouldGroupNodeBeOpened(pParentNode,
                                                                            UIChooserNodeDataPrefixType_Local,
-                                                                           strSecondSubName),
-                               strSecondSubName,
-                               UIChooserNodeGroupType_Local);
+                                                                           strSecondSubName));
     return strSecondSuffix.isEmpty() ? pNewGroupNode : getLocalGroupNode(strFirstSuffix, pNewGroupNode, fAllGroupsOpened);
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 86740)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 86742)
@@ -467,7 +467,8 @@
                 UIChooserNodeGroup *pNewGroupNode = new UIChooserNodeGroup(parentItem()->node(),
                                                                            parentItem()->node()->nodes().size(),
-                                                                           true /* opened */,
+                                                                           QUuid() /* id */,
                                                                            UIChooserModel::uniqueGroupName(parentItem()->node()),
-                                                                           parentItem()->node()->toGroupNode()->groupType());
+                                                                           parentItem()->node()->toGroupNode()->groupType(),
+                                                                           true /* opened */);
                 UIChooserItemGroup *pNewGroupItem = new UIChooserItemGroup(parentItem(), pNewGroupNode);
                 UIChooserNodeMachine *pNewMachineNode1 = new UIChooserNodeMachine(pNewGroupNode,
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 86740)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 86742)
@@ -791,7 +791,8 @@
         pTargetGroupNode = new UIChooserNodeGroup(invisibleRoot(),
                                                   invisibleRoot()->nodes().size() /* position */,
-                                                  true /* opened */,
+                                                  QUuid() /* id */,
                                                   uniqueGroupName(invisibleRoot()),
-                                                  UIChooserNodeGroupType_Local);
+                                                  UIChooserNodeGroupType_Local,
+                                                  true /* opened */);
         pTargetGroupItem = new UIChooserItemGroup(root(), pTargetGroupNode);
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp	(revision 86740)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp	(revision 86742)
@@ -28,11 +28,13 @@
 UIChooserNodeGroup::UIChooserNodeGroup(UIChooserNode *pParent,
                                        int iPosition,
-                                       bool fOpened,
+                                       const QUuid &uId,
                                        const QString &strName,
-                                       UIChooserNodeGroupType enmGroupType)
+                                       UIChooserNodeGroupType enmGroupType,
+                                       bool fOpened)
     : UIChooserNode(pParent, false /* favorite */)
-    , m_fOpened(fOpened)
+    , m_uId(uId)
     , m_strName(strName)
     , m_enmGroupType(enmGroupType)
+    , m_fOpened(fOpened)
 {
     /* Add to parent: */
@@ -48,7 +50,8 @@
                                        UIChooserNodeGroup *pCopyFrom)
     : UIChooserNode(pParent, false /* favorite */)
-    , m_fOpened(pCopyFrom->isOpened())
+    , m_uId(pCopyFrom->id())
     , m_strName(pCopyFrom->name())
     , m_enmGroupType(pCopyFrom->groupType())
+    , m_fOpened(pCopyFrom->isOpened())
 {
     /* Add to parent: */
@@ -287,4 +290,9 @@
 }
 
+QUuid UIChooserNodeGroup::id() const
+{
+    return m_uId;
+}
+
 void UIChooserNodeGroup::retranslateUi()
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.h	(revision 86740)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.h	(revision 86742)
@@ -34,13 +34,15 @@
 
     /** Constructs chooser node passing @a pParent to the base-class.
-      * @param  iPosition     Brings the initial node position
-      * @param  fOpened       Brings whether this group node is opened..
+      * @param  iPosition     Brings the initial node position.
+      * @param  uId           Brings current node id.
       * @param  strName       Brings current node name.
-      * @param  enmGroupType  Brings group node type. */
+      * @param  enmGroupType  Brings group node type.
+      * @param  fOpened       Brings whether this group node is opened. */
     UIChooserNodeGroup(UIChooserNode *pParent,
                        int iPosition,
-                       bool fOpened,
+                       const QUuid &uId,
                        const QString &strName,
-                       UIChooserNodeGroupType enmGroupType);
+                       UIChooserNodeGroupType enmGroupType,
+                       bool fOpened);
     /** Constructs chooser node passing @a pParent to the base-class.
       * @param  iPosition  Brings the initial node position.
@@ -108,4 +110,7 @@
     virtual void sortNodes() /* override */;
 
+    /** Returns node group id. */
+    QUuid id() const;
+
 protected:
 
@@ -118,10 +123,12 @@
     void copyContents(UIChooserNodeGroup *pCopyFrom);
 
-    /** Holds whether node is opened. */
-    bool                    m_fOpened;
+    /** Holds the node id. */
+    QUuid                   m_uId;
     /** Holds the node name. */
     QString                 m_strName;
     /** Holds the group node type. */
     UIChooserNodeGroupType  m_enmGroupType;
+    /** Holds whether node is opened. */
+    bool                    m_fOpened;
 
     /** Holds group children. */