Index: /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp	(revision 86865)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp	(revision 86866)
@@ -80,4 +80,5 @@
 static const int iBookmarkUrlDataType = 6;
 static const QPair<float, float> fontScaleMinMax(0.5f, 3.f);
+static int iFontPointSizeChangeStep = 2;
 
 /*********************************************************************************************************************************
@@ -303,4 +304,5 @@
     int initialFontPointSize() const;
     void setFontPointSize(int iPointSize);
+    int fontPointSize() const;
 
 private slots:
@@ -368,4 +370,5 @@
     int initialFontPointSize() const;
     void setFontPointSize(int iPointSize);
+    int fontPointSize() const;
 
 protected:
@@ -477,10 +480,9 @@
     if (!sender())
         return;
-    int iStep = 2;
     int iNewSize = m_iFontPointSize;
     if (sender() == m_pMinusButton)
-        iNewSize -= iStep;
+        iNewSize -= iFontPointSizeChangeStep;
     else if (sender() == m_pPlusButton)
-        iNewSize += iStep;
+        iNewSize += iFontPointSizeChangeStep;
     else if (sender() == m_pResetButton)
         iNewSize = m_iInitialFontPointSize;
@@ -767,4 +769,11 @@
 }
 
+int UIHelpBrowserTab::fontPointSize() const
+{
+    if (!m_pContentViewer)
+        return 0;
+    return m_pContentViewer->font().pointSize();
+}
+
 void UIHelpBrowserTab::prepare(const QUrl &initialUrl)
 {
@@ -1352,4 +1361,12 @@
     if (m_pFontScaleWidget)
         m_pFontScaleWidget->setFontPointSize(iPointSize);
+}
+
+int UIHelpBrowserTabManager::fontPointSize() const
+{
+    UIHelpBrowserTab *pTab = qobject_cast<UIHelpBrowserTab*>(currentWidget());
+    if (!pTab)
+        return 0;
+    return pTab->fontPointSize();
 }
 
@@ -1448,4 +1465,7 @@
     , m_pShowHideSideBarAction(0)
     , m_pShowHideToolBarAction(0)
+    , m_pFontSizeLargerAction(0)
+    , m_pFontSizeSmallerAction(0)
+    , m_pFontSizeResetAction(0)
     , m_fModelContentCreated(false)
 {
@@ -1457,5 +1477,4 @@
 UIHelpBrowserWidget::~UIHelpBrowserWidget()
 {
-    /* Cleanup VM Log-Viewer: */
     cleanup();
 }
@@ -1477,10 +1496,8 @@
 void UIHelpBrowserWidget::prepare()
 {
-    /* Create main layout: */
     m_pMainLayout = new QVBoxLayout(this);
     AssertReturnVoid(m_pMainLayout);
 
     prepareActions();
-    //prepareToolBar();
     prepareWidgets();
     prepareSearchWidgets();
@@ -1506,4 +1523,20 @@
     connect(m_pPrintDialogAction, &QAction::triggered,
             this, &UIHelpBrowserWidget::sltShowPrintDialog);
+
+    m_pFontSizeLargerAction = new QAction(this);
+    m_pFontSizeLargerAction->setIcon(UIIconPool::iconSet(":/help_browser_plus_32px.png"));
+
+    m_pFontSizeSmallerAction = new QAction(this);
+    m_pFontSizeSmallerAction->setIcon(UIIconPool::iconSet(":/help_browser_minus_32px.png"));
+
+    m_pFontSizeResetAction = new QAction(this);
+    m_pFontSizeResetAction->setIcon(UIIconPool::iconSet(":/help_browser_reset_32px.png"));
+
+    connect(m_pFontSizeLargerAction, &QAction::triggered,
+            this, &UIHelpBrowserWidget::sltHandleFontSizeactions);
+    connect(m_pFontSizeSmallerAction, &QAction::triggered,
+            this, &UIHelpBrowserWidget::sltHandleFontSizeactions);
+    connect(m_pFontSizeResetAction, &QAction::triggered,
+            this, &UIHelpBrowserWidget::sltHandleFontSizeactions);
 }
 
@@ -1590,15 +1623,8 @@
     connect(m_pSearchResultWidget, &QHelpContentWidget::customContextMenuRequested,
             this, &UIHelpBrowserWidget::sltShowLinksContextMenu);
-
-    // connect(searchEngine, &QHelpSearchEngine::searchingStarted,
-    //         this, &SearchWidget::searchingStarted);
-    // connect(searchEngine, &QHelpSearchEngine::searchingFinished,
-    //         this, &SearchWidget::searchingFinished);
-
     connect(m_pSearchEngine, &QHelpSearchEngine::indexingStarted,
             this, &UIHelpBrowserWidget::sltHandleIndexingStarted);
     connect(m_pSearchEngine, &QHelpSearchEngine::indexingFinished,
             this, &UIHelpBrowserWidget::sltHandleIndexingFinished);
-
     connect(m_pSearchEngine, &QHelpSearchEngine::searchingStarted,
             this, &UIHelpBrowserWidget::sltHandleSearchingStarted);
@@ -1610,16 +1636,10 @@
 {
     m_pTopLayout = new QHBoxLayout;
-    /* Create toolbar: */
     m_pToolBar = new QIToolBar(parentWidget());
     if (m_pToolBar)
     {
-        /* Configure toolbar: */
         m_pToolBar->setToolButtonStyle(Qt::ToolButtonIconOnly);
         const int iIconMetric = (int)(QApplication::style()->pixelMetric(QStyle::PM_LargeIconSize));
         m_pToolBar->setIconSize(QSize(iIconMetric, iIconMetric));
-        // m_pToolBar->addAction(m_pBackwardAction);
-        // m_pToolBar->addAction(m_pForwardAction);
-        // m_pToolBar->addAction(m_pHomeAction);
-        // m_pToolBar->addAction(m_pAddBookmarkAction);
 
 #ifdef VBOX_WS_MAC
@@ -1648,4 +1668,11 @@
         m_pFileMenu->addAction(m_pPrintDialogAction);
 
+    if (m_pFontSizeLargerAction)
+        m_pViewMenu->addAction(m_pFontSizeLargerAction);
+    if (m_pFontSizeSmallerAction)
+        m_pViewMenu->addAction(m_pFontSizeSmallerAction);
+    if (m_pFontSizeResetAction)
+        m_pViewMenu->addAction(m_pFontSizeResetAction);
+    m_pViewMenu->addSeparator();
     if (m_pShowHideSideBarAction)
         m_pViewMenu->addAction(m_pShowHideSideBarAction);
@@ -1656,20 +1683,4 @@
 void UIHelpBrowserWidget::loadOptions()
 {
-    // if (m_pContentViewer && m_pHelpEngine)
-    // {
-    //     QUrl url(gEDataManager->helpBrowserLastUrl());
-    //     if (url.isEmpty())
-    //         return;
-    //     if (url.isValid())
-    //     {
-    //         if (m_pHelpEngine->findFile(url).isValid())
-    //         {
-    //             m_pContentViewer->setSource(url);
-    //             m_pContentViewer->clearHistory();
-    //         }
-    //         else
-    //             show404Error(url);
-    //     }
-    // }
 }
 
@@ -1753,11 +1764,18 @@
         m_pTabWidget->setTabText(HelpBrowserTabs_Bookmarks, tr("Bookmarks"));
     }
+
     if (m_pShowHideSideBarAction)
-        m_pShowHideSideBarAction->setText(tr("Show/Hide Side Bar"));
-
+        m_pShowHideSideBarAction->setText(tr("Show Side Bar"));
     if (m_pShowHideToolBarAction)
-        m_pShowHideToolBarAction->setText(tr("Show/Hide Tool Bar"));
+        m_pShowHideToolBarAction->setText(tr("Show Tool Bar"));
     if (m_pPrintDialogAction)
         m_pPrintDialogAction->setText(tr("Print..."));
+
+    if (m_pFontSizeLargerAction)
+        m_pFontSizeLargerAction->setText(tr("Increase Font Size"));
+    if (m_pFontSizeSmallerAction)
+        m_pFontSizeSmallerAction->setText(tr("Decrease Font Size"));
+    if (m_pFontSizeResetAction)
+        m_pFontSizeResetAction->setText(tr("Reset Font Size"));
 }
 
@@ -1766,14 +1784,6 @@
 {
     QWidget::showEvent(pEvent);
-
-    /* One may think that QWidget::polish() is the right place to do things
-     * below, but apparently, by the time when QWidget::polish() is called,
-     * the widget style & layout are not fully done, at least the minimum
-     * size hint is not properly calculated. Since this is sometimes necessary,
-     * we provide our own "polish" implementation: */
-
-    if (m_fIsPolished)
-        return;
-
+   if (m_fIsPolished)
+        return;
     m_fIsPolished = true;
 }
@@ -1803,8 +1813,5 @@
     QPrintDialog printDialog(&printer, this);
     if (printDialog.exec() == QDialog::Accepted)
-    {
         m_pTabManager->printCurrent(printer);
-        //   PrintWidget(this);
-    }
 }
 
@@ -1855,5 +1862,4 @@
     if (m_pSearchContainerWidget)
         m_pSearchContainerWidget->setEnabled(false);
-    printf("indexing started\n");
 }
 
@@ -1862,11 +1868,8 @@
     if (m_pSearchContainerWidget)
         m_pSearchContainerWidget->setEnabled(true);
-
-    printf("indexing finished\n");
 }
 
 void UIHelpBrowserWidget::sltHandleSearchingStarted()
 {
-
 }
 
@@ -1955,4 +1958,18 @@
 }
 
+void UIHelpBrowserWidget::sltHandleFontSizeactions()
+{
+    if (!sender() || !m_pTabManager)
+        return;
+    int iFontPointSize = m_pTabManager->fontPointSize();
+    if (sender() == m_pFontSizeResetAction)
+        iFontPointSize = m_pTabManager->initialFontPointSize();
+    else if (sender() == m_pFontSizeLargerAction)
+        iFontPointSize += iFontPointSizeChangeStep;
+    else if (sender() == m_pFontSizeSmallerAction)
+        iFontPointSize -= iFontPointSizeChangeStep;
+    m_pTabManager->setFontPointSize(iFontPointSize);
+}
+
 #include "UIHelpBrowserWidget.moc"
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h	(revision 86865)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h	(revision 86866)
@@ -101,4 +101,5 @@
     void sltOpenLink();
     void sltAddNewBookmark(const QUrl &url, const QString &strTitle);
+    void sltHandleFontSizeactions();
 
 private:
@@ -167,4 +168,7 @@
     QAction             *m_pShowHideSideBarAction;
     QAction             *m_pShowHideToolBarAction;
+    QAction             *m_pFontSizeLargerAction;
+    QAction             *m_pFontSizeSmallerAction;
+    QAction             *m_pFontSizeResetAction;
     /* This is set t true when handling QHelpContentModel::contentsCreated signal. */
     bool                 m_fModelContentCreated;