Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 86939)
@@ -295,4 +295,5 @@
         <file alias="soft_keyboard_16px.png">images/soft_keyboard_16px.png</file>
         <file alias="soft_keyboard_32px.png">images/soft_keyboard_32px.png</file>
+        <file alias="soft_keyboard_help_16px.png">images/soft_keyboard_help_16px.png</file>
         <file alias="soft_keyboard_layout_copy_16px.png">images/soft_keyboard_layout_copy_16px.png</file>
         <file alias="soft_keyboard_layout_copy_disabled_16px.png">images/soft_keyboard_layout_copy_disabled_16px.png</file>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/UITakeSnapshotDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/UITakeSnapshotDialog.cpp	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/UITakeSnapshotDialog.cpp	(revision 86939)
@@ -280,7 +280,7 @@
             connect(m_pButtonBox, &QIDialogButtonBox::rejected,
                     this, &UITakeSnapshotDialog::reject);
-            connect(m_pButtonBox, &QIDialogButtonBox::helpRequested,
-                    &msgCenter(), &UIMessageCenter::sltShowHelpHelpDialog);
-
+            connect(m_pButtonBox->button(QIDialogButtonBox::Help), &QPushButton::pressed,
+                    &(msgCenter()), &UIMessageCenter::sltHandleDialogHelpButtonPress);
+            m_pButtonBox->button(QIDialogButtonBox::Help)->setProperty("helptag", "snapshots");
             /* Add into layout: */
             pLayout->addWidget(m_pButtonBox, 3, 0, 1, 2);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 86939)
@@ -3471,5 +3471,4 @@
 {
 # if defined(VBOX_WITH_DOCS_QHELP) && (QT_VERSION >= QT_VERSION_CHECK(5, 9, 0))
-
     QAbstractButton *pSender = qobject_cast<QAbstractButton*>(sender());
     if (!pSender)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.cpp	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.cpp	(revision 86939)
@@ -102,4 +102,9 @@
 }
 
+void UIFileManagerDialog::configureButtonBox()
+{
+    configureButtonBoxHelpButton("guestadd-gc-file-manager");
+}
+
 void UIFileManagerDialog::finalize()
 {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.h	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.h	(revision 86939)
@@ -86,4 +86,6 @@
         /** Configures central-widget. */
         virtual void configureCentralWidget() /* override */;
+        /** Configures button box. */
+        virtual void configureButtonBox() /* override */;
         /** Perform final preparations. */
         virtual void finalize() /* override */;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerDialog.cpp	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerDialog.cpp	(revision 86939)
@@ -106,4 +106,9 @@
 }
 
+void UIVMLogViewerDialog::configureButtonBox()
+{
+    configureButtonBoxHelpButton("collect-debug-info");
+}
+
 void UIVMLogViewerDialog::finalize()
 {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerDialog.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerDialog.h	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerDialog.h	(revision 86939)
@@ -93,4 +93,5 @@
         /** Configures central-widget. */
         virtual void configureCentralWidget() /* override */;
+        virtual void configureButtonBox() /* override */;
         /** Perform final preparations. */
         virtual void finalize() /* override */;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 86939)
@@ -22,21 +22,23 @@
 
 /* GUI includes: */
-#include "UIVMInformationDialog.h"
-#include "UIExtraDataManager.h"
-#include "UISession.h"
-#include "UIMachineLogic.h"
-#include "UIMachineWindow.h"
-#include "UIMachineView.h"
-#include "UIConverter.h"
-#include "UIIconPool.h"
 #include "QITabWidget.h"
 #include "QIDialogButtonBox.h"
 #include "UICommon.h"
-#include "VBoxUtils.h"
+#include "UIConverter.h"
+#include "UIExtraDataManager.h"
+#include "UIIconPool.h"
 #include "UIInformationConfiguration.h"
-#include "UIPerformanceMonitor.h"
 #include "UIInformationRuntime.h"
 #include "UIGuestProcessControlWidget.h"
+#include "UIMachineLogic.h"
 #include "UIMachine.h"
+#include "UIMachineView.h"
+#include "UIMachineWindow.h"
+#include "UIMessageCenter.h"
+#include "UIPerformanceMonitor.h"
+#include "UISession.h"
+#include "UIVMInformationDialog.h"
+#include "VBoxUtils.h"
+
 
 /* COM includes: */
@@ -245,8 +247,11 @@
     {
         /* Configure button-box: */
-        m_pButtonBox->setStandardButtons(QDialogButtonBox::Close);
+        m_pButtonBox->setStandardButtons(QDialogButtonBox::Close | QDialogButtonBox::Help);
         m_pButtonBox->button(QDialogButtonBox::Close)->setShortcut(Qt::Key_Escape);
+        m_pButtonBox->button(QDialogButtonBox::Help)->setProperty("helptag", "guestadd-guestprops");
         connect(m_pButtonBox, &QIDialogButtonBox::rejected, this, &UIVMInformationDialog::close);
-        /* Add button-box into main-layout: */
+        connect(m_pButtonBox->button(QDialogButtonBox::Help), &QPushButton::pressed,
+                &(msgCenter()), &UIMessageCenter::sltHandleDialogHelpButtonPress);
+        /* add button-box into main-layout: */
         centralWidget()->layout()->addWidget(m_pButtonBox);
     }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 86938)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 86939)
@@ -831,4 +831,5 @@
     QToolButton  *m_pSettingsButton;
     QToolButton  *m_pResetButton;
+    QToolButton  *m_pHelpButton;
     QLabel       *m_pMessageLabel;
 };
@@ -3562,4 +3563,5 @@
     , m_pSettingsButton(0)
     , m_pResetButton(0)
+    , m_pHelpButton(0)
     , m_pMessageLabel(0)
 {
@@ -3575,4 +3577,6 @@
     if (m_pResetButton)
         m_pResetButton->setToolTip(UISoftKeyboard::tr("Reset the keyboard and release all keys"));
+    if (m_pHelpButton)
+        m_pHelpButton->setToolTip(UISoftKeyboard::tr("Help"));
 }
 
@@ -3622,4 +3626,17 @@
         connect(m_pResetButton, &QToolButton::clicked, this, &UISoftKeyboardStatusBarWidget::sigResetKeyboard);
         pLayout->addWidget(m_pResetButton);
+    }
+
+    m_pHelpButton = new QToolButton;
+    if (m_pHelpButton)
+    {
+        m_pHelpButton->setIcon(UIIconPool::iconSet(":/soft_keyboard_help_16px.png"));
+        m_pHelpButton->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
+        const int iIconMetric = QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
+        m_pHelpButton->resize(QSize(iIconMetric, iIconMetric));
+        m_pHelpButton->setStyleSheet("QToolButton { border: 0px none black; margin: 0px 0px 0px 0px; } QToolButton::menu-indicator {image: none;}");
+        m_pHelpButton->setProperty("helptag", "soft-keyb");
+        connect(m_pHelpButton, &QToolButton::clicked, &(msgCenter()), &UIMessageCenter::sltHandleDialogHelpButtonPress);
+        pLayout->addWidget(m_pHelpButton);
     }
 