Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp	(revision 86958)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp	(revision 86959)
@@ -1128,2 +1128,56 @@
     return "Unknown";
 }
+
+/**
+ * Converts Shared Clipboard formats to a string.
+ *
+ * @returns Stringified Shared Clipboard formats, or NULL on failure. Must be free'd with RTStrFree().
+ * @param   fFormats            Shared Clipboard formats to convert.
+ *
+ */
+char *ShClFormatsToStrA(SHCLFORMATS fFormats)
+{
+#define APPEND_FMT_TO_STR(_aFmt)                \
+    if (fFormats & VBOX_SHCL_FMT_##_aFmt)       \
+    {                                           \
+        if (pszFmts)                            \
+        {                                       \
+            rc2 = RTStrAAppend(&pszFmts, ", "); \
+            if (RT_FAILURE(rc2))                \
+                break;                          \
+        }                                       \
+                                                \
+        rc2 = RTStrAAppend(&pszFmts, #_aFmt);   \
+        if (RT_FAILURE(rc2))                    \
+            break;                              \
+    }
+
+    char *pszFmts = NULL;
+    int rc2 = VINF_SUCCESS;
+
+    do
+    {
+        APPEND_FMT_TO_STR(UNICODETEXT);
+        APPEND_FMT_TO_STR(BITMAP);
+        APPEND_FMT_TO_STR(HTML);
+# ifdef VBOX_WITH_SHARED_CLIPBOARD_TRANSFERS
+        APPEND_FMT_TO_STR(URI_LIST);
+# endif
+
+    } while (0);
+
+    if (!pszFmts)
+        rc2 = RTStrAAppend(&pszFmts, "NONE");
+
+    if (   RT_FAILURE(rc2)
+        && pszFmts)
+    {
+        RTStrFree(pszFmts);
+        pszFmts = NULL;
+    }
+
+#undef APPEND_FMT_TO_STR
+
+    return pszFmts;
+}
+
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-x11.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-x11.cpp	(revision 86958)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-x11.cpp	(revision 86959)
@@ -48,4 +48,5 @@
 #include <X11/StringDefs.h>
 
+#include <iprt/assert.h>
 #include <iprt/types.h>
 #include <iprt/mem.h>
@@ -444,5 +445,10 @@
     LogFlow((" -> vboxFmt=%#x\n", vboxFmt));
 
-    LogRel2(("Shared Clipboard: X11 reported available VBox formats: %#x\n", vboxFmt));
+#ifdef LOG_ENABLED
+    char *pszFmts = ShClFormatsToStrA(vboxFmt);
+    AssertPtrReturnVoid(pszFmts);
+    LogRel2(("Shared Clipboard: X11 reported available VBox formats '%s'\n", pszFmts));
+    RTStrFree(pszFmts);
+#endif
 
     ShClX11ReportFormatsCallback(pCtx->pFrontend, vboxFmt);
@@ -1585,6 +1591,11 @@
                  pCtx->vboxFormats, idxFmtX11, g_aFormats[idxFmtX11].pcszAtom, fmtX11));
 
-    LogRel2(("Shared Clipboard: Converting VBox formats %#x to '%s' for X11\n",
-             pCtx->vboxFormats, g_aFormats[idxFmtX11].pcszAtom));
+#ifdef LOG_ENABLED
+    char *pszFmts = ShClFormatsToStrA(pCtx->vboxFormats);
+    AssertPtrReturn(pszFmts, VERR_NO_MEMORY);
+    LogRel2(("Shared Clipboard: Converting VBox formats '%s' to '%s' for X11\n",
+             pszFmts, g_aFormats[idxFmtX11].pcszAtom));
+    RTStrFree(pszFmts);
+#endif
 
     if (   ((fmtX11 == SHCLX11FMT_UTF8) || (fmtX11 == SHCLX11FMT_TEXT))
@@ -1696,6 +1707,11 @@
 
     if (RT_FAILURE(rc))
-        LogRel(("Shared Clipboard: Converting VBox formats %#x to '%s' for X11 (idxFmtX11=%u, fmtX11=%u) failed, rc=%Rrc\n",
-                pCtx->vboxFormats, g_aFormats[idxFmtX11].pcszAtom, idxFmtX11, fmtX11, rc));
+    {
+        char *pszFmts2 = ShClFormatsToStrA(pCtx->vboxFormats);
+        AssertPtrReturn(pszFmts2, VERR_NO_MEMORY);
+        LogRel(("Shared Clipboard: Converting VBox formats '%s' to '%s' for X11 (idxFmtX11=%u, fmtX11=%u) failed, rc=%Rrc\n",
+                pszFmts2, g_aFormats[idxFmtX11].pcszAtom, idxFmtX11, fmtX11, rc));
+        RTStrFree(pszFmts2);
+    }
 
     LogFlowFuncLeaveRC(rc);
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 86958)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 86959)
@@ -1213,4 +1213,10 @@
         fFormats &= ~fFormat;
 
+#ifdef LOG_ENABLED
+        char *pszFmt = ShClFormatsToStrA(fFormat);
+        AssertPtrReturn(pszFmt, VERR_NO_MEMORY);
+        LogRel2(("Shared Clipboard: Requesting guest clipboard data in format '%s'\n", pszFmt));
+        RTStrFree(pszFmt);
+#endif
         /*
          * Allocate messages, one for each format.
@@ -1389,9 +1395,16 @@
     if (!(g_fTransferMode & VBOX_SHCL_TRANSFER_MODE_ENABLED))
     {
-        LogFlowFunc(("fFormats=%#x -> %#x\n", fFormats, fFormats & ~VBOX_SHCL_FMT_URI_LIST));
         fFormats &= ~VBOX_SHCL_FMT_URI_LIST;
     }
+    else
+        LogRel2(("Shared Clipboard: Warning: File transfers are disabled, ignoring\n"));
 #endif
-    LogRel2(("Shared Clipboard: Reporting formats %#x to guest\n", fFormats));
+
+#ifdef LOG_ENABLED
+    char *pszFmts = ShClFormatsToStrA(fFormats);
+    AssertPtrReturn(pszFmts, VERR_NO_MEMORY);
+    LogRel2(("Shared Clipboard: Reporting formats '%s' to guest\n", pszFmts));
+    RTStrFree(pszFmts);
+#endif
 
     /*
@@ -1508,4 +1521,10 @@
             else
             {
+#ifdef LOG_ENABLED
+                char *pszFmts = ShClFormatsToStrA(fFormats);
+                AssertPtrReturn(pszFmts, VERR_NO_MEMORY);
+                LogRel2(("Shared Clipboard: Guest reported formats '%s' to host\n", pszFmts));
+                RTStrFree(pszFmts);
+#endif
                 rc = ShClBackendFormatAnnounce(pClient, fFormats);
                 if (RT_FAILURE(rc))
@@ -1606,5 +1625,10 @@
     }
 
-    LogRel2(("Shared Clipboard: Guest wants to read %RU32 bytes host clipboard data in format %RU32\n", cbData, uFormat));
+#ifdef LOG_ENABLED
+    char *pszFmt = ShClFormatsToStrA(uFormat);
+    AssertPtrReturn(pszFmt, VERR_NO_MEMORY);
+    LogRel2(("Shared Clipboard: Guest wants to read %RU32 bytes host clipboard data in format '%s'\n", cbData, pszFmt));
+    RTStrFree(pszFmt);
+#endif
 
     /*
@@ -1796,5 +1820,10 @@
     }
 
-    LogRel2(("Shared Clipboard: Guest writes %RU32 bytes clipboard data in format %RU32 to host\n", cbData, uFormat));
+#ifdef LOG_ENABLED
+    char *pszFmt = ShClFormatsToStrA(uFormat);
+    AssertPtrReturn(pszFmt, VERR_NO_MEMORY);
+    LogRel2(("Shared Clipboard: Guest writes %RU32 bytes clipboard data in format '%s' to host\n", cbData, pszFmt));
+    RTStrFree(pszFmt);
+#endif
 
     /*