Index: trunk/src/VBox/Runtime/r3/ftp-server.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/ftp-server.cpp	(revision 86780)
+++ trunk/src/VBox/Runtime/r3/ftp-server.cpp	(revision 86973)
@@ -326,5 +326,5 @@
 
 /** Function pointer declaration for a specific FTP server command handler. */
-typedef DECLCALLBACKTYPE(int, FNRTFTPSERVERCMD,(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs));
+typedef DECLCALLBACKTYPE(int, FNRTFTPSERVERCMD,(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs));
 /** Pointer to a FNRTFTPSERVERCMD(). */
 typedef FNRTFTPSERVERCMD *PFNRTFTPSERVERCMD;
@@ -337,5 +337,5 @@
 static int  rtFtpServerDataConnClose(PRTFTPSERVERDATACONN pDataConn);
 static void rtFtpServerDataConnReset(PRTFTPSERVERDATACONN pDataConn);
-static int  rtFtpServerDataConnStart(PRTFTPSERVERDATACONN pDataConn, PFNRTTHREAD pfnThread, uint8_t cArgs, const char * const *apcszArgs);
+static int  rtFtpServerDataConnStart(PRTFTPSERVERDATACONN pDataConn, PFNRTTHREAD pfnThread, uint8_t cArgs, const char * const *apszArgs);
 static int  rtFtpServerDataConnStop(PRTFTPSERVERDATACONN pDataConn);
 static void rtFtpServerDataConnDestroy(PRTFTPSERVERDATACONN pDataConn);
@@ -375,7 +375,5 @@
     /** Command ID. */
     RTFTPSERVERCMD      enmCmd;
-    /** Command represented as ASCII string.
-     * @todo r=bird: It's a waste to use 64 byte here when all supported commands
-     *       are 3 or 4 chars + terminator.  For (64-bit) alignment reasons,  */
+    /** Command represented as ASCII string. */
     char                szCmd[RTFTPSERVER_MAX_CMD_LEN];
     /** Whether the commands needs a logged in (valid) user. */
@@ -466,15 +464,15 @@
  * @param   pClient             Client to reply to.
  * @param   enmReply            Reply code to send.
- * @param   pcszFormat          Format string of message to send with the reply code.
+ * @param   pszFormat           Format string of message to send with the reply code.
  */
 static int rtFtpServerSendReplyRcEx(PRTFTPSERVERCLIENT pClient, RTFTPSERVER_REPLY enmReply,
-                                    const char *pcszFormat, ...)
+                                    const char *pszFormat, ...)
 {
     char *pszMsg = NULL;
 
     va_list args;
-    va_start(args, pcszFormat);
+    va_start(args, pszFormat);
     char *pszFmt = NULL;
-    const int cch = RTStrAPrintfV(&pszFmt, pcszFormat, args);
+    const int cch = RTStrAPrintfV(&pszFmt, pszFormat, args);
     va_end(args);
     AssertReturn(cch > 0, VERR_NO_MEMORY);
@@ -512,13 +510,13 @@
  * @returns VBox status code.
  * @param   pClient             Client to reply to.
- * @param   pcszFormat          Format to reply.
+ * @param   pszFormat           Format to reply.
  * @param   ...                 Format arguments.
  */
-static int rtFtpServerSendReplyStr(PRTFTPSERVERCLIENT pClient, const char *pcszFormat, ...)
+static int rtFtpServerSendReplyStr(PRTFTPSERVERCLIENT pClient, const char *pszFormat, ...)
 {
     va_list args;
-    va_start(args, pcszFormat);
+    va_start(args, pszFormat);
     char *psz = NULL;
-    const int cch = RTStrAPrintfV(&psz, pcszFormat, args);
+    const int cch = RTStrAPrintfV(&psz, pszFormat, args);
     va_end(args);
     AssertReturn(cch > 0, VERR_NO_MEMORY);
@@ -540,20 +538,20 @@
  *
  * @returns \c true if path is valid, or \c false if not.
- * @param   pcszPath            Path to check.
+ * @param   pszPath             Path to check.
  * @param   fIsAbsolute         Whether the path to check is an absolute path or not.
  */
-static bool rtFtpServerPathIsValid(const char *pcszPath, bool fIsAbsolute)
-{
-    if (!pcszPath)
+static bool rtFtpServerPathIsValid(const char *pszPath, bool fIsAbsolute)
+{
+    if (!pszPath)
         return false;
 
-    bool fIsValid =    strlen(pcszPath)
-                    && RTStrIsValidEncoding(pcszPath)
-                    && RTStrStr(pcszPath, "..") == NULL;     /** @todo Very crude for now -- improve this. */
+    bool fIsValid =    strlen(pszPath)
+                    && RTStrIsValidEncoding(pszPath)
+                    && RTStrStr(pszPath, "..") == NULL;     /** @todo Very crude for now -- improve this. */
     if (   fIsValid
         && fIsAbsolute)
     {
         RTFSOBJINFO objInfo;
-        int rc2 = RTPathQueryInfo(pcszPath, &objInfo, RTFSOBJATTRADD_NOTHING);
+        int rc2 = RTPathQueryInfo(pszPath, &objInfo, RTFSOBJATTRADD_NOTHING);
         if (RT_SUCCESS(rc2))
         {
@@ -567,5 +565,5 @@
     }
 
-    LogFlowFunc(("pcszPath=%s -> %RTbool\n", pcszPath, fIsValid));
+    LogFlowFunc(("pszPath=%s -> %RTbool\n", pszPath, fIsValid));
     return fIsValid;
 }
@@ -576,14 +574,14 @@
  * @returns VBox status code.
  * @param   pState              Client state to set current working directory for.
- * @param   pcszPath            Working directory to set.
- */
-static int rtFtpSetCWD(PRTFTPSERVERCLIENTSTATE pState, const char *pcszPath)
+ * @param   pszPath             Working directory to set.
+ */
+static int rtFtpSetCWD(PRTFTPSERVERCLIENTSTATE pState, const char *pszPath)
 {
     RTStrFree(pState->pszCWD);
 
-    if (!rtFtpServerPathIsValid(pcszPath, false /* fIsAbsolute */))
+    if (!rtFtpServerPathIsValid(pszPath, false /* fIsAbsolute */))
         return VERR_INVALID_PARAMETER;
 
-    pState->pszCWD = RTStrDup(pcszPath);
+    pState->pszCWD = RTStrDup(pszPath);
 
     LogFlowFunc(("Current CWD is now '%s'\n", pState->pszCWD));
@@ -599,9 +597,9 @@
  * @returns VBox status code, or VERR_NOT_FOUND if user has not been found.
  * @param   pClient             Client to look up user for.
- * @param   pcszUser            User name to look up.
- */
-static int rtFtpServerLookupUser(PRTFTPSERVERCLIENT pClient, const char *pcszUser)
-{
-    RTFTPSERVER_HANDLE_CALLBACK_VA_RET(pfnOnUserConnect, pcszUser);
+ * @param   pszUser             User name to look up.
+ */
+static int rtFtpServerLookupUser(PRTFTPSERVERCLIENT pClient, const char *pszUser)
+{
+    RTFTPSERVER_HANDLE_CALLBACK_VA_RET(pfnOnUserConnect, pszUser);
 }
 
@@ -611,10 +609,10 @@
  * @returns VBox status code, or VERR_ACCESS_DENIED if authentication failed.
  * @param   pClient             Client to authenticate.
- * @param   pcszUser            User name to authenticate with.
- * @param   pcszPassword        Password to authenticate with.
- */
-static int rtFtpServerAuthenticate(PRTFTPSERVERCLIENT pClient, const char *pcszUser, const char *pcszPassword)
-{
-    RTFTPSERVER_HANDLE_CALLBACK_VA_RET(pfnOnUserAuthenticate, pcszUser, pcszPassword);
+ * @param   pszUser             User name to authenticate with.
+ * @param   pszPassword         Password to authenticate with.
+ */
+static int rtFtpServerAuthenticate(PRTFTPSERVERCLIENT pClient, const char *pszUser, const char *pszPassword)
+{
+    RTFTPSERVER_HANDLE_CALLBACK_VA_RET(pfnOnUserAuthenticate, pszUser, pszPassword);
 }
 
@@ -713,11 +711,11 @@
  *
  * @returns VBox status code.
- * @param   pcszStr             String to parse.
+ * @param   pszStr              String to parse.
  * @param   pAddr               Where to store the IPv4 address on success.
  * @param   puPort              Where to store the port number on success.
  */
-static int rtFtpParseHostAndPort(const char *pcszStr, PRTNETADDRIPV4 pAddr, uint16_t *puPort)
-{
-    AssertPtrReturn(pcszStr, VERR_INVALID_POINTER);
+static int rtFtpParseHostAndPort(const char *pszStr, PRTNETADDRIPV4 pAddr, uint16_t *puPort)
+{
+    AssertPtrReturn(pszStr, VERR_INVALID_POINTER);
     AssertPtrReturn(pAddr, VERR_INVALID_POINTER);
     AssertPtrReturn(puPort, VERR_INVALID_POINTER);
@@ -728,5 +726,5 @@
     /* Parse IP (v4). */
     /** @todo I don't think IPv6 ever will be a thing here, or will it? */
-    rc = RTStrToUInt8Ex(pcszStr, &pszNext, 10, &pAddr->au8[0]);
+    rc = RTStrToUInt8Ex(pszStr, &pszNext, 10, &pAddr->au8[0]);
     if (rc != VINF_SUCCESS && rc != VWRN_TRAILING_CHARS)
         return VERR_INVALID_PARAMETER;
@@ -774,13 +772,13 @@
  * @returns Duplicated argument vector or NULL if failed or no arguments given. Needs to be free'd with rtFtpCmdArgsFree().
  * @param   cArgs               Number of arguments in argument vector.
- * @param   apcszArgs           Pointer to argument vector to duplicate.
- */
-static char** rtFtpCmdArgsDup(uint8_t cArgs, const char * const *apcszArgs)
+ * @param   apszArgs            Pointer to argument vector to duplicate.
+ */
+static char** rtFtpCmdArgsDup(uint8_t cArgs, const char * const *apszArgs)
 {
     if (!cArgs)
         return NULL;
 
-    char **apcszArgsDup = (char **)RTMemAlloc(cArgs * sizeof(char *));
-    if (!apcszArgsDup)
+    char **apszArgsDup = (char **)RTMemAlloc(cArgs * sizeof(char *));
+    if (!apszArgsDup)
     {
         AssertFailed();
@@ -793,6 +791,6 @@
     for (i = 0; i < cArgs; i++)
     {
-        apcszArgsDup[i] = RTStrDup(apcszArgs[i]);
-        if (!apcszArgsDup[i])
+        apszArgsDup[i] = RTStrDup(apszArgs[i]);
+        if (!apszArgsDup[i])
             rc2 = VERR_NO_MEMORY;
     }
@@ -801,11 +799,11 @@
     {
         while (i--)
-            RTStrFree(apcszArgsDup[i]);
-
-        RTMemFree(apcszArgsDup);
+            RTStrFree(apszArgsDup[i]);
+
+        RTMemFree(apszArgsDup);
         return NULL;
     }
 
-    return apcszArgsDup;
+    return apszArgsDup;
 }
 
@@ -814,12 +812,12 @@
  *
  * @param   cArgs               Number of arguments in argument vector.
- * @param   papcszArgs          Pointer to argument vector to free.
- */
-static void rtFtpCmdArgsFree(uint8_t cArgs, char **papcszArgs)
+ * @param   papszArgs           Pointer to argument vector to free.
+ */
+static void rtFtpCmdArgsFree(uint8_t cArgs, char **papszArgs)
 {
     while (cArgs--)
-        RTStrFree(papcszArgs[cArgs]);
-
-    RTMemFree(papcszArgs);
+        RTStrFree(papszArgs[cArgs]);
+
+    RTMemFree(papszArgs);
 }
 
@@ -1001,12 +999,12 @@
  * @returns VBox status code.
  * @param   pDataConn           Data connection to write to.
- * @param   pcszFormat          Format string to send. No (terminal) termination added.
- */
-static int rtFtpServerDataConnPrintf(PRTFTPSERVERDATACONN pDataConn, const char *pcszFormat, ...)
+ * @param   pszFormat           Format string to send. No (terminal) termination added.
+ */
+static int rtFtpServerDataConnPrintf(PRTFTPSERVERDATACONN pDataConn, const char *pszFormat, ...)
 {
     va_list args;
-    va_start(args, pcszFormat);
+    va_start(args, pszFormat);
     char *pszFmt = NULL;
-    const int cch = RTStrAPrintfV(&pszFmt, pcszFormat, args);
+    const int cch = RTStrAPrintfV(&pszFmt, pszFormat, args);
     va_end(args);
     AssertReturn(cch > 0, VERR_NO_MEMORY);
@@ -1057,10 +1055,10 @@
 
     AssertPtr(pDataConn->papszArgs);
-    const char *pcszFile = pDataConn->papszArgs[0];
-    AssertPtr(pcszFile);
+    const char *pszFile = pDataConn->papszArgs[0];
+    AssertPtr(pszFile);
 
     void *pvHandle = NULL; /* Opaque handle known to the actual implementation. */
 
-    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileOpen, pcszFile,
+    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileOpen, pszFile,
                                    RTFILE_O_READ | RTFILE_O_OPEN | RTFILE_O_DENY_WRITE, &pvHandle);
     if (RT_SUCCESS(rc))
@@ -1142,8 +1140,8 @@
  * @param   pfnThread           Thread function for the data connection to use.
  * @param   cArgs               Number of arguments.
- * @param   apcszArgs           Array of arguments.
+ * @param   apszArgs            Array of arguments.
  */
 static int rtFtpServerDataConnStart(PRTFTPSERVERDATACONN pDataConn, PFNRTTHREAD pfnThread,
-                                    uint8_t cArgs, const char * const *apcszArgs)
+                                    uint8_t cArgs, const char * const *apszArgs)
 {
     AssertPtrReturn(pDataConn, VERR_INVALID_POINTER);
@@ -1158,5 +1156,5 @@
     if (cArgs)
     {
-        pDataConn->papszArgs = rtFtpCmdArgsDup(cArgs, apcszArgs);
+        pDataConn->papszArgs = rtFtpCmdArgsDup(cArgs, apszArgs);
         if (!pDataConn->papszArgs)
             rc = VERR_NO_MEMORY;
@@ -1279,7 +1277,7 @@
 *********************************************************************************************************************************/
 
-static DECLCALLBACK(int) rtFtpServerHandleABOR(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandleABOR(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(cArgs, apszArgs);
 
     int rc = rtFtpServerDataConnClose(pClient->pDataConn);
@@ -1295,7 +1293,7 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleCDUP(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandleCDUP(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(cArgs, apszArgs);
 
     int rc;
@@ -1331,5 +1329,5 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleCWD(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandleCWD(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1)
@@ -1338,13 +1336,13 @@
     int rc;
 
-    const char *pcszPath = apcszArgs[0];
-
-    if (!rtFtpServerPathIsValid(pcszPath, false /* fIsAbsolute */))
+    const char *pszPath = apszArgs[0];
+
+    if (!rtFtpServerPathIsValid(pszPath, false /* fIsAbsolute */))
         return VERR_INVALID_PARAMETER;
 
-    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnPathSetCurrent, pcszPath);
+    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnPathSetCurrent, pszPath);
 
     if (RT_SUCCESS(rc))
-        rc = rtFtpSetCWD(&pClient->State, pcszPath);
+        rc = rtFtpSetCWD(&pClient->State, pszPath);
 
     return rtFtpServerSendReplyRc(pClient,
@@ -1353,7 +1351,7 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleFEAT(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandleFEAT(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(cArgs, apszArgs);
 
     int rc = rtFtpServerSendReplyStr(pClient, "211-BEGIN Features:");
@@ -1871,13 +1869,13 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleLIST(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandleLIST(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     /* If no argument is given, use the server's CWD as the path. */
-    const char *pcszPath = cArgs ? apcszArgs[0] : pClient->State.pszCWD;
-    AssertPtr(pcszPath);
+    const char *pszPath = cArgs ? apszArgs[0] : pClient->State.pszCWD;
+    AssertPtr(pszPath);
 
     int rc = VINF_SUCCESS;
 
-    if (!rtFtpServerPathIsValid(pcszPath, false /* fIsAbsolute */))
+    if (!rtFtpServerPathIsValid(pszPath, false /* fIsAbsolute */))
     {
         int rc2 = rtFtpServerSendReplyRc(pClient, RTFTPSERVER_REPLY_CONN_REQ_FILE_ACTION_NOT_TAKEN);
@@ -1886,5 +1884,5 @@
     else
     {
-        RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileStat, pcszPath, NULL /* PRTFSOBJINFO */);
+        RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileStat, pszPath, NULL /* PRTFSOBJINFO */);
 
         if (RT_SUCCESS(rc))
@@ -1894,5 +1892,5 @@
                 rc = rtFtpServerDataConnCreate(pClient, &pClient->pDataConn);
                 if (RT_SUCCESS(rc))
-                    rc = rtFtpServerDataConnStart(pClient->pDataConn, rtFtpServerDataConnListThread, cArgs, apcszArgs);
+                    rc = rtFtpServerDataConnStart(pClient->pDataConn, rtFtpServerDataConnListThread, cArgs, apszArgs);
 
                 int rc2 = rtFtpServerSendReplyRc(  pClient, RT_SUCCESS(rc)
@@ -1917,7 +1915,7 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleMODE(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(pClient, cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandleMODE(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(pClient, cArgs, apszArgs);
 
     /** @todo Anything to do here? */
@@ -1925,7 +1923,7 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleNOOP(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandleNOOP(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(cArgs, apszArgs);
 
     /* Save timestamp of last command sent. */
@@ -1935,13 +1933,13 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandlePASS(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandlePASS(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1)
         return rtFtpServerSendReplyRc(pClient, RTFTPSERVER_REPLY_ERROR_INVALID_PARAMETERS);
 
-    const char *pcszPassword = apcszArgs[0];
-    AssertPtrReturn(pcszPassword, VERR_INVALID_PARAMETER);
-
-    int rc = rtFtpServerAuthenticate(pClient, pClient->State.pszUser, pcszPassword);
+    const char *pszPassword = apszArgs[0];
+    AssertPtrReturn(pszPassword, VERR_INVALID_PARAMETER);
+
+    int rc = rtFtpServerAuthenticate(pClient, pClient->State.pszUser, pszPassword);
     if (RT_SUCCESS(rc))
     {
@@ -1960,5 +1958,5 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandlePORT(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandlePORT(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1)
@@ -1967,5 +1965,5 @@
     RTFTPSERVER_REPLY rcClient;
 
-    int rc = rtFtpParseHostAndPort(apcszArgs[0], &pClient->DataConnAddr, &pClient->uDataConnPort);
+    int rc = rtFtpParseHostAndPort(apszArgs[0], &pClient->DataConnAddr, &pClient->uDataConnPort);
     if (RT_SUCCESS(rc))
         rcClient = RTFTPSERVER_REPLY_OKAY;
@@ -1980,7 +1978,7 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandlePWD(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandlePWD(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(cArgs, apszArgs);
 
     int rc;
@@ -1996,7 +1994,7 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleOPTS(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandleOPTS(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(cArgs, apszArgs);
 
     int rc = VINF_SUCCESS;
@@ -2009,7 +2007,7 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleQUIT(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandleQUIT(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(cArgs, apszArgs);
 
     int rc = VINF_SUCCESS;
@@ -2032,5 +2030,5 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleRETR(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandleRETR(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1) /* File name needs to be present. */
@@ -2039,7 +2037,7 @@
     int rc;
 
-    const char *pcszPath = apcszArgs[0];
-
-    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileStat, pcszPath, NULL /* PRTFSOBJINFO */);
+    const char *pszPath = apszArgs[0];
+
+    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileStat, pszPath, NULL /* PRTFSOBJINFO */);
 
     if (RT_SUCCESS(rc))
@@ -2051,5 +2049,5 @@
                 rc = rtFtpServerDataConnCreate(pClient, &pClient->pDataConn);
                 if (RT_SUCCESS(rc))
-                    rc = rtFtpServerDataConnStart(pClient->pDataConn, rtFtpServerDataConnFileWriteThread, cArgs, apcszArgs);
+                    rc = rtFtpServerDataConnStart(pClient->pDataConn, rtFtpServerDataConnFileWriteThread, cArgs, apszArgs);
 
                 int rc2 = rtFtpServerSendReplyRc(  pClient, RT_SUCCESS(rc)
@@ -2080,5 +2078,5 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleSIZE(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandleSIZE(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1)
@@ -2087,8 +2085,8 @@
     int rc;
 
-    const char *pcszPath = apcszArgs[0];
+    const char *pszPath = apszArgs[0];
     uint64_t uSize = 0;
 
-    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileGetSize, pcszPath, &uSize);
+    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileGetSize, pszPath, &uSize);
 
     if (RT_SUCCESS(rc))
@@ -2105,5 +2103,5 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleSTAT(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandleSTAT(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1)
@@ -2115,7 +2113,7 @@
     RT_ZERO(objInfo);
 
-    const char *pcszPath = apcszArgs[0];
-
-    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileStat, pcszPath, &objInfo);
+    const char *pszPath = apszArgs[0];
+
+    RTFTPSERVER_HANDLE_CALLBACK_VA(pfnOnFileStat, pszPath, &objInfo);
 
     if (RT_SUCCESS(rc))
@@ -2126,5 +2124,5 @@
         {
             char szFsPathInfo[RTPATH_MAX + 16];
-            const ssize_t cchPathInfo = RTStrPrintf2(szFsPathInfo, sizeof(szFsPathInfo), " %2zu %s\n", strlen(pcszPath), pcszPath);
+            const ssize_t cchPathInfo = RTStrPrintf2(szFsPathInfo, sizeof(szFsPathInfo), " %2zu %s\n", strlen(pszPath), pszPath);
             if (cchPathInfo > 0)
             {
@@ -2147,14 +2145,14 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleSTRU(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandleSTRU(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1)
         return VERR_INVALID_PARAMETER;
 
-    const char *pcszType = apcszArgs[0];
+    const char *pszType = apszArgs[0];
 
     int rc;
 
-    if (!RTStrICmp(pcszType, "F"))
+    if (!RTStrICmp(pszType, "F"))
     {
         pClient->State.enmStructType = RTFTPSERVER_STRUCT_TYPE_FILE;
@@ -2168,7 +2166,7 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleSYST(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
-{
-    RT_NOREF(cArgs, apcszArgs);
+static DECLCALLBACK(int) rtFtpServerHandleSYST(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
+{
+    RT_NOREF(cArgs, apszArgs);
 
     char szOSInfo[64];
@@ -2180,18 +2178,18 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleTYPE(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandleTYPE(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1)
         return VERR_INVALID_PARAMETER;
 
-    const char *pcszType = apcszArgs[0];
+    const char *pszType = apszArgs[0];
 
     int rc = VINF_SUCCESS;
 
-    if (!RTStrICmp(pcszType, "A"))
+    if (!RTStrICmp(pszType, "A"))
     {
         pClient->State.enmDataType = RTFTPSERVER_DATA_TYPE_ASCII;
     }
-    else if (!RTStrICmp(pcszType, "I")) /* Image (binary). */
+    else if (!RTStrICmp(pszType, "I")) /* Image (binary). */
     {
         pClient->State.enmDataType = RTFTPSERVER_DATA_TYPE_IMAGE;
@@ -2206,18 +2204,18 @@
 }
 
-static DECLCALLBACK(int) rtFtpServerHandleUSER(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apcszArgs)
+static DECLCALLBACK(int) rtFtpServerHandleUSER(PRTFTPSERVERCLIENT pClient, uint8_t cArgs, const char * const *apszArgs)
 {
     if (cArgs != 1)
         return VERR_INVALID_PARAMETER;
 
-    const char *pcszUser = apcszArgs[0];
-    AssertPtrReturn(pcszUser, VERR_INVALID_PARAMETER);
+    const char *pszUser = apszArgs[0];
+    AssertPtrReturn(pszUser, VERR_INVALID_PARAMETER);
 
     rtFtpServerClientStateReset(&pClient->State);
 
-    int rc = rtFtpServerLookupUser(pClient, pcszUser);
+    int rc = rtFtpServerLookupUser(pClient, pszUser);
     if (RT_SUCCESS(rc))
     {
-        pClient->State.pszUser = RTStrDup(pcszUser);
+        pClient->State.pszUser = RTStrDup(pszUser);
         AssertPtrReturn(pClient->State.pszUser, VERR_NO_MEMORY);
 
@@ -2245,14 +2243,14 @@
  *
  * @returns VBox status code.
- * @param   pcszCmdParms        Pointer to command arguments, if any. Can be NULL if no arguments are given.
+ * @param   pszCmdParms         Pointer to command arguments, if any. Can be NULL if no arguments are given.
  * @param   pcArgs              Returns the number of parsed arguments, separated by a space (hex 0x20).
- * @param   ppapcszArgs         Returns the string array of parsed arguments. Needs to be free'd with rtFtpServerCmdArgsFree().
- */
-static int rtFtpServerCmdArgsParse(const char *pcszCmdParms, uint8_t *pcArgs, char ***ppapcszArgs)
+ * @param   ppapszArgs          Returns the string array of parsed arguments. Needs to be free'd with rtFtpServerCmdArgsFree().
+ */
+static int rtFtpServerCmdArgsParse(const char *pszCmdParms, uint8_t *pcArgs, char ***ppapszArgs)
 {
     *pcArgs      = 0;
-    *ppapcszArgs = NULL;
-
-    if (!pcszCmdParms) /* No parms given? Bail out early. */
+    *ppapszArgs = NULL;
+
+    if (!pszCmdParms) /* No parms given? Bail out early. */
         return VINF_SUCCESS;
 
@@ -2261,5 +2259,5 @@
 
     int cArgs = 0;
-    int rc = RTGetOptArgvFromString(ppapcszArgs, &cArgs, pcszCmdParms, RTGETOPTARGV_CNV_QUOTE_MS_CRT, " " /* Separators */);
+    int rc = RTGetOptArgvFromString(ppapszArgs, &cArgs, pszCmdParms, RTGETOPTARGV_CNV_QUOTE_MS_CRT, " " /* Separators */);
     if (RT_SUCCESS(rc))
     {
@@ -2278,9 +2276,9 @@
  * Frees a formerly argument string array parsed by rtFtpServerCmdArgsParse().
  *
- * @param   ppapcszArgs         Argument string array to free.
- */
-static void rtFtpServerCmdArgsFree(char **ppapcszArgs)
-{
-    RTGetOptArgvFree(ppapcszArgs);
+ * @param   ppapszArgs          Argument string array to free.
+ */
+static void rtFtpServerCmdArgsFree(char **ppapszArgs)
+{
+    RTGetOptArgvFree(ppapszArgs);
 }
 
@@ -2290,22 +2288,18 @@
  * @returns VBox status code.
  * @param   pClient             Client to process commands for.
- * @param   pcszCmd             Command string to parse and handle.
+ * @param   pszCmd              Command string to parse and handle.
  * @param   cbCmd               Size (in bytes) of command string.
  */
-static int rtFtpServerProcessCommands(PRTFTPSERVERCLIENT pClient, char *pcszCmd, size_t cbCmd)
-{
-    /** @todo r=bird: pcszCmd is a misnomer, it is _clearly_ not const as you
-     * modify it all over the place!  Please do _not_use 'c' to mean 'const', it
-     * means 'count of'. */
+static int rtFtpServerProcessCommands(PRTFTPSERVERCLIENT pClient, char *pszCmd, size_t cbCmd)
+{
     /* Make sure to terminate the string in any case. */
-    pcszCmd[RT_MIN(RTFTPSERVER_MAX_CMD_LEN, cbCmd)] = '\0';
+    pszCmd[RT_MIN(RTFTPSERVER_MAX_CMD_LEN, cbCmd)] = '\0';
 
     /* A tiny bit of sanitation. */
-    RTStrStripL(pcszCmd);
+    RTStrStripL(pszCmd);
 
     /* First, terminate string by finding the command end marker (telnet style). */
     /** @todo Not sure if this is entirely correct and/or needs tweaking; good enough for now as it seems. */
-    /** @todo r=bird: Why are you using the case-insensitive version here? */
-    char *pszCmdEnd = RTStrIStr(pcszCmd, "\r\n");
+    char *pszCmdEnd = RTStrStr(pszCmd, "\r\n");
     if (pszCmdEnd)
         *pszCmdEnd = '\0';
@@ -2318,5 +2312,5 @@
     uint8_t cArgs     = 0;
     char  **papszArgs = NULL;
-    int rc = rtFtpServerCmdArgsParse(pcszCmd, &cArgs, &papszArgs);
+    int rc = rtFtpServerCmdArgsParse(pszCmd, &cArgs, &papszArgs);
     if (   RT_SUCCESS(rc)
         && cArgs) /* At least the actual command (without args) must be present. */
@@ -2415,5 +2409,5 @@
  *       (even in C++ code, see init() methods in the API).
  */
-static int rtFtpServerProcessCommands(PRTFTPSERVERCLIENT pClient)
+static int rtFtpServerClientMain(PRTFTPSERVERCLIENT pClient)
 {
     int rc;
@@ -2527,5 +2521,5 @@
         ASMAtomicIncU32(&pThis->cClients);
 
-        rc = rtFtpServerProcessCommands(&Client);
+        rc = rtFtpServerClientMain(&Client);
 
         ASMAtomicDecU32(&pThis->cClients);
@@ -2537,9 +2531,9 @@
 }
 
-RTR3DECL(int) RTFtpServerCreate(PRTFTPSERVER phFTPServer, const char *pcszAddress, uint16_t uPort,
+RTR3DECL(int) RTFtpServerCreate(PRTFTPSERVER phFTPServer, const char *pszAddress, uint16_t uPort,
                                 PRTFTPSERVERCALLBACKS pCallbacks, void *pvUser, size_t cbUser)
 {
     AssertPtrReturn(phFTPServer,  VERR_INVALID_POINTER);
-    AssertPtrReturn(pcszAddress,  VERR_INVALID_POINTER);
+    AssertPtrReturn(pszAddress,  VERR_INVALID_POINTER);
     AssertReturn   (uPort,        VERR_INVALID_PARAMETER);
     AssertPtrReturn(pCallbacks,   VERR_INVALID_POINTER);
@@ -2556,5 +2550,5 @@
         pThis->cbUser    = cbUser;
 
-        rc = RTTcpServerCreate(pcszAddress, uPort, RTTHREADTYPE_DEFAULT, "ftpsrv",
+        rc = RTTcpServerCreate(pszAddress, uPort, RTTHREADTYPE_DEFAULT, "ftpsrv",
                                rtFtpServerClientThread, pThis /* pvUser */, &pThis->pTCPServer);
         if (RT_SUCCESS(rc))